unit MainForm_buttons;

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls,

  modul_cpu, modul_pio, wincpm,
  MainForm_cpu, MainForm_ram, MainForm_trace;

type

  { TTForm_BUTTONS }

  TTForm_BUTTONS = class(TForm)
    Button_Save_Memo: TButton;
    Button_Clear_Memo: TButton;
    Button_Auto_Stop: TButton;
    Button_Start_oP: TButton;
    Button_einen_Befehl_abarbeiten: TButton;
    Button_TRACE: TButton;
    Button_RAM: TButton;
    Button_CPU: TButton;
    CheckBox_LOG_ESC: TCheckBox;
    CheckBox_CPM_AutoStart: TCheckBox;
    CheckBox_LOG_READ: TCheckBox;
    CheckBox_BreakPoint: TCheckBox;
    Edit_Adress: TEdit;
    Image_3_gr: TImage;
    Image_2_gr: TImage;
    Image_1_gr: TImage;
    Image_3_gn: TImage;
    Image_2_gn: TImage;
    Image_1_gn: TImage;
    Label1: TLabel;
    Memo_Protokoll: TMemo;
    procedure Button_Auto_StopClick(Sender: TObject);
    procedure Button_Clear_MemoClick(Sender: TObject);
    procedure Button_Save_MemoClick(Sender: TObject);
    procedure Button_Start_oPClick(Sender: TObject);
    procedure Button_CPUClick(Sender: TObject);
    procedure Button_einen_Befehl_abarbeitenClick(Sender: TObject);
    procedure Button_RAMClick(Sender: TObject);
    procedure Button_TRACEClick(Sender: TObject);
    procedure CheckBox_BreakPointChange(Sender: TObject);
    procedure CheckBox_CPM_AutoStartChange(Sender: TObject);
    procedure CheckBox_LOG_READChange(Sender: TObject);
    procedure Edit_AdressChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure Button_1_ein;
    procedure Button_2_ein;
    procedure Button_3_ein;
    procedure Adresse_setzen(Adresse : STRING);
  end;

var
  TForm_BUTTONS: TTForm_BUTTONS;

implementation

uses
  MainForm_EMUZ80;


{ TTForm_BUTTONS }






procedure TTForm_BUTTONS.FormCreate(Sender: TObject);
begin

  CheckBox_BreakPoint.Checked:=false;
  Edit_Adress.Enabled:=false;
  Memo_Protokoll.Clear;
  CheckBox_LOG_ESC.Checked:=false;


  Image_1_gn.Left:=648;
  Image_1_gn.Top:=16;
  Image_1_gn.Visible:=false;

  Image_2_gn.Left:=648;
  Image_2_gn.Top:=56;
  Image_2_gn.Visible:=false;

  Image_3_gn.Left:=648;
  Image_3_gn.Top:=96;
  Image_3_gn.Visible:=false;


  Image_1_gr.Left:=648;
  Image_1_gr.Top:=16;
  Image_1_gr.Visible:=true;

  Image_2_gr.Left:=648;
  Image_2_gr.Top:=56;
  Image_2_gr.Visible:=true;

  Image_3_gr.Left:=648;
  Image_3_gr.Top:=96;
  Image_3_gr.Visible:=true;



  // IMAGE LW_A
  wcpm_LW_A := Twcpm.Create(Memo_Protokoll,Form_EMUZ80.Image_Disk_LW_A,
                            Form_EMUZ80.Programm_File_Pfad+Form_EMUZ80.CPM_DIR_LW_A);
  wcpm_LW_A.load_dpb_FormatE;
  // wcpm_LW_A.load_dpb_img;
  // wcpm_LW_A.load_dpb_dsk;
  wcpm_LW_A.Import_Files_To_Image;

  // IMAGE LW_B
  wcpm_LW_B := Twcpm.Create(Memo_Protokoll,Form_EMUZ80.Image_Disk_LW_B,
                            Form_EMUZ80.Programm_File_Pfad+Form_EMUZ80.CPM_DIR_LW_B);
  wcpm_LW_B.load_dpb_FormatE;
  // wcpm_LW_B.load_dpb_img;
  // wcpm_LW_B.load_dpb_dsk;
  wcpm_LW_B.Import_Files_To_Image;


end; { procedure TTForm_BUTTONS.FormCreate }










{ *** Prozeduren zu den Buttons *** }


procedure TTForm_BUTTONS.Button_1_ein;
begin

  Image_1_gn.Visible:=true;
  Image_2_gn.Visible:=false;
  Image_3_gn.Visible:=false;
  Image_1_gr.Visible:=false;
  Image_2_gr.Visible:=true;
  Image_3_gr.Visible:=true;

end; { procedure TTForm_BUTTONS.Button_1_ein }


procedure TTForm_BUTTONS.Button_2_ein;
begin

  Image_1_gn.Visible:=false;
  Image_2_gn.Visible:=true;
  Image_3_gn.Visible:=false;
  Image_1_gr.Visible:=true;
  Image_2_gr.Visible:=false;
  Image_3_gr.Visible:=true;

end; { procedure TTForm_BUTTONS.Button_2_ein }


procedure TTForm_BUTTONS.Button_3_ein;
begin

  Image_1_gn.Visible:=false;
  Image_2_gn.Visible:=false;
  Image_3_gn.Visible:=true;
  Image_1_gr.Visible:=true;
  Image_2_gr.Visible:=true;
  Image_3_gr.Visible:=false;

end; { procedure TTForm_BUTTONS.Button_3_ein }



procedure TTForm_BUTTONS.Button_einen_Befehl_abarbeitenClick(Sender: TObject);
begin
  Button_1_ein;

  Form_EMUZ80.Z80.Mode_Protokoll:=true;
  Form_EMUZ80.EMU_Mode_Run:=false;

  Form_EMUZ80.Z80.einen_Befehl_abarbeiten;

  if Form_EMUZ80.Form_RAM_aktiv then
    Form_RAM.Inhalt_anzeigen;

  if Form_EMUZ80.Form_CPU_aktiv then
    Form_cpu.Register_anzeigen;

  if Form_EMUZ80.Form_TRACE_aktiv then
    Form_TRACE.ASM_Zeile_anzeigen(mod_cpu.Reg.SRS.PC);

end; { procedure TTForm_BUTTONS.Button_einen_Befehl_abarbeitenClick }




procedure TTForm_BUTTONS.Button_Start_oPClick(Sender: TObject);
begin
  Button_2_ein;
  Form_EMUZ80.EMU_Mode_Run:=true;
  Form_EMUZ80.EMU_Mode_Trace:=false;
  Form_EMUZ80.Z80.Mode_Protokoll:=false;
end; { procedure TTForm_BUTTONS.Button_Start_oPClick }





procedure TTForm_BUTTONS.Button_Auto_StopClick(Sender: TObject);
begin
  Button_3_ein;
  Form_EMUZ80.Z80.Mode_Protokoll:=true;
  Form_EMUZ80.EMU_Mode_Trace:=false;
  Form_EMUZ80.EMU_Mode_Run:=false;
end; { procedure TTForm_BUTTONS.Button_Auto_StopClick }







procedure TTForm_BUTTONS.Button_CPUClick(Sender: TObject);
begin
  if Form_EMUZ80.Form_CPU_aktiv then begin
    Form_EMUZ80.Form_CPU_aktiv:=false;
    Form_cpu.Visible:=false;
  end
  else begin
    Form_EMUZ80.Form_CPU_aktiv:=true;
    Form_cpu.Visible:=true;
    Form_cpu.Register_anzeigen;

  end; { if Form_CPU_aktiv then }
end; { procedure TTForm_BUTTONS.Button_CPUClick }






procedure TTForm_BUTTONS.Button_RAMClick(Sender: TObject);
begin
  if Form_EMUZ80.Form_RAM_aktiv then begin
    Form_EMUZ80.Form_RAM_aktiv:=false;
    Form_RAM.Visible:=false;
  end
  else begin
    Form_EMUZ80.Form_RAM_aktiv:=true;
    Form_RAM.Visible:=true;
    Form_RAM.Inhalt_anzeigen;

  end; { if Form_RAM_aktiv then }
end; { procedure TTForm_BUTTONS.Button_RAMClick }




procedure TTForm_BUTTONS.Button_TRACEClick(Sender: TObject);
begin
  if Form_EMUZ80.Form_TRACE_aktiv then begin
    Form_trace.Visible:=false;
    Form_EMUZ80.Form_TRACE_aktiv:=false;
  end
  else begin
    Form_trace.Visible:=true;
    Form_EMUZ80.Form_TRACE_aktiv:=true;

  end; { if Form_TRACE_aktiv then }

end; { procedure TTForm_BUTTONS.Button_TRACEClick }




{ Unterbrechungspunkt }


procedure TTForm_BUTTONS.CheckBox_BreakPointChange(Sender: TObject);
begin
  if CheckBox_BreakPoint.Checked then begin
    Edit_Adress.Enabled:=true;
  end
  else begin
    Edit_Adress.Enabled:=false;
  end;
end; { procedure TTForm_BUTTONS.CheckBox_BreakPointChange }







procedure TTForm_BUTTONS.Edit_AdressChange(Sender: TObject);
var
  Adresse_STR : String;
  Adress_LI : LongInt;
begin

  if CheckBox_BreakPoint.Checked then begin
    Adresse_STR:='$'+Edit_Adress.Text;
    Adress_LI:=StrToIntDef(Adresse_STR,$FFFFFF);

    if Adress_LI=$FFFFFF then begin
      Form_EMUZ80.Z80.Adresse_WORD:=0;
    end
    else begin

      if (Adress_LI>=0) and (Adress_LI<=$FFFF) then
        Form_EMUZ80.Z80.Adresse_WORD:=Word(Adress_LI)
      else
        Form_EMUZ80.Z80.Adresse_WORD:=0;;

    end; { if Adress_LI=$FFFFFF then }

    Edit_Adress.Text:=IntToHex(Form_EMUZ80.Z80.Adresse_WORD,4);

    mod_pio.CONIN_Buffer:='';

  end; { if Form_EMUZ80.CheckBox_BreakPoint.Checked then }

end; { procedure TTForm_BUTTONS.Edit_AdressChange }







{ Sektor anzeigen }


procedure TTForm_BUTTONS.CheckBox_LOG_READChange(Sender: TObject);
begin
  if CheckBox_LOG_READ.Checked then begin
    Form_EMUZ80.LOG_READ := true;
  end
  else begin
    Form_EMUZ80.LOG_READ := false;
  end; { if CheckBox_LOG_READ.Enabled then }
end; { procedure TTForm_BUTTONS.CheckBox_LOG_READChange }






{ CP/M automatisch starten }


procedure TTForm_BUTTONS.CheckBox_CPM_AutoStartChange(Sender: TObject);
begin

  if CheckBox_CPM_AutoStart.Checked then begin
    Form_EMUZ80.CPM_AutoStart:=true;
  end
  else begin
    Form_EMUZ80.CPM_AutoStart:=false;
  end;
end; { procedure TTForm_BUTTONS.CheckBox_CPM_AutoStartChange }





{ Protokoll bearbeiten }




procedure TTForm_BUTTONS.Button_Clear_MemoClick(Sender: TObject);
begin
   Memo_Protokoll.Lines.Clear;
end; { procedure TTForm_BUTTONS.Button_Clear_MemoClick }




procedure TTForm_BUTTONS.Button_Save_MemoClick(Sender: TObject);
begin
  Memo_Protokoll.Lines.SaveToFile('Protokoll.txt');
end; { procedure TTForm_BUTTONS.Button_Save_MemoClick }










procedure TTForm_BUTTONS.Adresse_setzen(Adresse : STRING);
var
  Adresse_STR : String;
  Adress_LI : LongInt;
begin
  CheckBox_BreakPoint.Checked:=true;
  Edit_Adress.Text:=Adresse;
  Adresse_STR:='$'+Edit_Adress.Text;
  Adress_LI:=StrToIntDef(Adresse_STR,$FFFFFF);

  if (Adress_LI>=0) and (Adress_LI<=$FFFF) then
    Form_EMUZ80.Z80.Adresse_WORD:=Word(Adress_LI);

end; { procedure TTForm_BUTTONS.Adresse_setzen }









{ Schliessen }




procedure TTForm_BUTTONS.FormClose(Sender: TObject;
                                   var CloseAction: TCloseAction);
begin

  Visible:=false;
  Form_EMUZ80.Form_Button_aktiv:=false;

end; { procedure TTForm_BUTTONS.FormClose }






procedure TTForm_BUTTONS.FormDestroy(Sender: TObject);
begin

  Form_EMUZ80.Button_Left:=TForm_BUTTONS.Left;
  Form_EMUZ80.Button_Top:=TForm_BUTTONS.Top;

  Memo_Protokoll.Lines.SaveToFile('Protokoll.txt');

end; { procedure TTForm_BUTTONS.FormDestroy }





initialization
  {$I mainform_buttons.lrs}

end.

