unit MainForm_trace;

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, SynEdit, SynHighlighterAny, LResources, Forms,
  Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, SynEditMarks, SynGutterBase;



const
  Trace_Pfad = 'TRACE';
  List_Array_Laenge = 100000;


type

  // Daten-Satz
  TRC_DATEN_REC = record
    Adresse, Befehl, Zeilennummer, Bemerkung : String;
    gefunden : Boolean;
    ZeilenNr, Position_Befehl : Cardinal;
  end;



  { TForm_TRACE }

  TForm_TRACE = class(TForm)
    ImageList1: TImageList;
    SynAnySyn_Z80_ASM: TSynAnySyn;
    SynEdit_Z80_ASM: TSynEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SynEdit_Z80_ASMGutterClick(Sender: TObject; X, Y, Line: integer;
      mark: TSynEditMark);
  private
    { private declarations }
    List_Array : Array [0..List_Array_Laenge] of TRC_DATEN_REC;
    List_Array_Zeiger, TRACE_List_Offset : Cardinal;
    TRACE_List : TStringList;
    ASM_Source : TStringList;

    procedure ASM_Source_in_PRN_Datei;
    procedure TRACE_To_TRACE_List;
    procedure MACRO80_PRN_Datei_in_ARRAY_einlesen;
    procedure RMAC_PRN_Datei_in_ARRAY_einlesen;
    procedure ARRAY_Zeilen_markieren;
    procedure SynEditSelLine(const Line: Integer; const Synedit: TSynEdit);
  public
    { public declarations }
    procedure ASM_Zeile_anzeigen(Adresse : Word);
  end;

var
  Form_TRACE : TForm_TRACE;

implementation

{ TForm_TRACE }

uses
  MainForm_EMUZ80, MainForm_buttons;

procedure TForm_TRACE.FormCreate(Sender: TObject);
begin

  TRACE_List := TStringList.Create;

  ASM_Source := TStringList.Create;

  List_Array_Zeiger:=0;
  TRACE_List_Offset:=0;

  TRACE_To_TRACE_List;

  ASM_Source_in_PRN_Datei;

  ARRAY_Zeilen_markieren;

  Form_TRACE.Left:=Form_EMUZ80.TRACE_Left;
  Form_TRACE.Top:=Form_EMUZ80.TRACE_Top;
  Form_TRACE.Width:=Form_EMUZ80.TRACE_Width;
  Form_TRACE.Height:=Form_EMUZ80.TRACE_Height;

end; { procedure TForm_TRACE.FormCreate }








// Einlesen der Namen der PRN-Dateien in die Trace-Liste
procedure TForm_TRACE.TRACE_To_TRACE_List;
var
  Info : TSearchRec;
  Count : Longint;
  FileName : String;
begin
  TRACE_List.Clear;

  Count:=0;
  If FindFirst(Form_EMUZ80.Programm_File_Pfad+Trace_Pfad+Pfadtrenner+'*.PRN',faAnyFile,Info)=0 then
    begin
    Repeat
      Inc(Count);
      With Info do begin
          if (Info.Name<>'.') and (Info.Name<>'..') then begin
            // Dateinamen werden in CP/M immer gross geschrieben
            FileName := UpperCase(Info.Name);
            TRACE_List.Add(FileName);
          end; { if (Info.Name<>'.') and (Info.Name<>'..') then }
      end; { With Info do }
    Until FindNext(info)<>0;
    end;
  FindClose(Info);


//  TRACE_List.SaveToFile('TRACE_List.txt');

end; { procedure TForm_TRACE.TRACE_To_TRACE_List }










// Einlesen der PRN-Dateien in Source-Liste
procedure TForm_TRACE.ASM_Source_in_PRN_Datei;
var

  ASM_Zaehler : Integer;
  ASM_Zeile, ASM_Datei : String;
begin

    { Einlesen der  }

    SynEdit_Z80_ASM.Lines.Clear;

    for ASM_Zaehler:=0 to TRACE_List.Count-1 do begin
      ASM_Datei:=TRACE_List[ASM_Zaehler];
      ASM_Datei:=Form_EMUZ80.Programm_File_Pfad+Trace_Pfad+Pfadtrenner+ASM_Datei;
      ASM_Source.LoadFromFile(ASM_Datei);

      if ASM_Source.Count>0 then begin

        // aktuelle PRN-Datei in das Array einlesen

        if SynEdit_Z80_ASM.Lines.Count>0 then
          TRACE_List_Offset:=SynEdit_Z80_ASM.Lines.Count;


        ASM_Zeile:=ASM_Source[0];
        if pos('RMAC ASSEM',ASM_Zeile)>0 then begin
          RMAC_PRN_Datei_in_ARRAY_einlesen;
        end
        else begin

          if pos('MACRO-80',ASM_Zeile)>0 then begin
            MACRO80_PRN_Datei_in_ARRAY_einlesen;
          end
          else begin
            RMAC_PRN_Datei_in_ARRAY_einlesen;
          end; {  }

        end; { if pos('RMAC ASSEM',ASM_Zeile)>0 then }


        // aktuelle PRN-Datei in die TRACE-Liste anfuegen
        SynEdit_Z80_ASM.Lines.Text:=SynEdit_Z80_ASM.Lines.Text+ASM_Source.Text;

      end; { if ASM_Source.Count>0 then }

    end; { for ASM_Zaehler:=0 to TRACE_List.Count-1 do }

 //   SynEdit_Z80_ASM.Lines.SaveToFile('SynEdit_Z80_ASM.txt');

end; { procedure TForm_TRACE.ASM_Source_in_PRN_Datei }












procedure TForm_TRACE.MACRO80_PRN_Datei_in_ARRAY_einlesen;
var
  Zaehler : Integer;
  Zeile, STR_Adresse, STR_Daten,
  STR_ZeilenNummer : String;
  Zeichen : Char;

begin

  for Zaehler:=0 to ASM_Source.Count-1 do begin
    Zeile:=ASM_Source[Zaehler];
    if Pos(CHR($27),Zeile)=7 then begin
      Zeile[7]:=' ';
      ASM_Source[Zaehler]:=Zeile;
    end;
  end; { for Zaehler:=0 to ASM_Source.Count-1 do }


  for Zaehler:=0 to ASM_Source.Count-1 do begin

      Zeile:=ASM_Source[Zaehler];
      if Length(Zeile)>10 then begin
        if pos('  ',Zeile)=1 then begin
          Zeichen:=Zeile[3];
          if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
            Zeichen:=Zeile[4];
            if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
              Zeichen:=Zeile[5];
              if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
                Zeichen:=Zeile[6];
                if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
                  STR_Adresse:=Copy(Zeile,3,4);
                  if pos('    ',Zeile)=7 then begin
                    Zeichen:=Zeile[11];
                    if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
                      Zeichen:=Zeile[12];
                      if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
                        STR_Daten:=Copy(Zeile,11,2);
                        STR_ZeilenNummer:=IntToStr(Zaehler+TRACE_List_Offset);

                        if Zaehler<10 then
                          STR_ZeilenNummer:='0'+STR_ZeilenNummer;

                        if Zaehler<100 then
                          STR_ZeilenNummer:='0'+STR_ZeilenNummer;

                        if Zaehler<1000 then
                          STR_ZeilenNummer:='0'+STR_ZeilenNummer;

                        if Zaehler<10000 then
                          STR_ZeilenNummer:='0'+STR_ZeilenNummer;

                        List_Array[List_Array_Zeiger].Adresse:=STR_Adresse;
                        List_Array[List_Array_Zeiger].Befehl:=STR_Daten;
                        List_Array[List_Array_Zeiger].Zeilennummer:=STR_ZeilenNummer;
                        List_Array[List_Array_Zeiger].ZeilenNr:=Zaehler+TRACE_List_Offset;

                        if List_Array_Zeiger<List_Array_Laenge then
                          Inc(List_Array_Zeiger);

                      end; { if c1 IN ['0123456789ABCDEF'] then }
                    end; { if c1 IN ['0123456789ABCDEF'] then }
                  end; { if pos('    ',Zeile)=7 then }
                end; { if c1 IN ['0123456789ABCDEF'] then }
              end; { if c1 IN ['0123456789ABCDEF'] then }
            end; { if c1 IN ['0123456789ABCDEF'] then }
          end; { if c1 IN ['0123456789ABCDEF'] then }
        end; { if pos('  ',Zeile)=1 then }
      end; { if Length(Zeile)>10 then }
    end; { for Zaehler:=0 to SynEdit_Z80_ASM.Lines.Count-1 do }

end; { procedure TForm_TRACE.MACRO80_PRN_Datei_in_ARRAY_einlesen }










procedure TForm_TRACE.RMAC_PRN_Datei_in_ARRAY_einlesen;
var
  Zaehler : Integer;
  Zeile, STR_Adresse, STR_Daten,
  STR_ZeilenNummer : String;
  Zeichen : Char;


begin

  for Zaehler:=0 to ASM_Source.Count-1 do begin

      Zeile:=ASM_Source[Zaehler];
      if Length(Zeile)>10 then begin
        Zeichen:=Zeile[1];
        if Zeichen=' ' then begin
          Zeichen:=Zeile[2];
          if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
            Zeichen:=Zeile[3];
            if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
              Zeichen:=Zeile[4];
              if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
                Zeichen:=Zeile[5];
                if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
                  STR_Adresse:=Copy(Zeile,2,4);
                  Zeichen:=Zeile[6];
                  if Zeichen=' ' then begin
                    Zeichen:=Zeile[7];
                    if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
                      Zeichen:=Zeile[8];
                      if Zeichen IN ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'] then begin
                        STR_Daten:=Copy(Zeile,11,2);
                        STR_ZeilenNummer:=IntToStr(Zaehler+TRACE_List_Offset);

                        if Zaehler<10 then
                          STR_ZeilenNummer:='0'+STR_ZeilenNummer;

                        if Zaehler<100 then
                          STR_ZeilenNummer:='0'+STR_ZeilenNummer;

                        if Zaehler<1000 then
                          STR_ZeilenNummer:='0'+STR_ZeilenNummer;

                        if Zaehler<10000 then
                          STR_ZeilenNummer:='0'+STR_ZeilenNummer;

                        List_Array[List_Array_Zeiger].Adresse:=STR_Adresse;
                        List_Array[List_Array_Zeiger].Befehl:=STR_Daten;
                        List_Array[List_Array_Zeiger].Zeilennummer:=STR_ZeilenNummer;
                        List_Array[List_Array_Zeiger].ZeilenNr:=Zaehler+TRACE_List_Offset;

                        if List_Array_Zeiger<List_Array_Laenge then
                          Inc(List_Array_Zeiger);

                      end; { if c1 IN ['0123456789ABCDEF'] then }
                    end; { if c1 IN ['0123456789ABCDEF'] then }
                  end; { if pos('    ',Zeile)=7 then }
                end; { if c1 IN ['0123456789ABCDEF'] then }
              end; { if c1 IN ['0123456789ABCDEF'] then }
            end; { if c1 IN ['0123456789ABCDEF'] then }
          end; { if c1 IN ['0123456789ABCDEF'] then }
        end; { if pos('  ',Zeile)=1 then }
      end; { if Length(Zeile)>10 then }
    end; { for Zaehler:=0 to SynEdit_Z80_ASM.Lines.Count-1 do }


end; { procedure TForm_TRACE.RMAC_PRN_Datei_in_ARRAY_einlesen }












procedure TForm_TRACE.ARRAY_Zeilen_markieren;
var
  Zaehler : Integer;


  procedure Add_Gutter(ZeiNr : Integer);
  var
    m: TSynEditMark;
  begin
    m := TSynEditMark.Create(SynEdit_Z80_ASM);
    m.Line := ZeiNr;
    m.Visible := true;
    m.ImageList := ImageList1;
    m.ImageIndex := 0;
    SynEdit_Z80_ASM.Marks.Add(m);
  end;


begin


  for Zaehler:=0 to List_Array_Zeiger do begin
    Add_Gutter(List_Array[Zaehler].ZeilenNr+1);
  end; { for Zaehler:=0 to List_Array_Zeiger do }


end; { procedure TForm_TRACE.ARRAY_Zeilen_markieren }












// *** Anzeige der Zeile im Einzelschrittbetrieb





procedure TForm_TRACE.SynEditSelLine(const Line: Integer; const Synedit: TSynEdit);
{ Quelle: http://www.delphipraxis.net/66322-synedit-zeile-markieren.html }
var i, l: Integer;
begin
  if (Line < Synedit.Lines.Count + 1) and (Line > -1) and (Synedit <> nil) then
  begin
    l := 0;

    for i := -1 to Line -2 do
    inc(l, Length(Synedit.Lines[i]) + 2);

    Synedit.SelStart := l-1;
    Synedit.SelEnd := l + Length(Synedit.Lines[Line-1]);

  end;
end; { procedure SynEditSelLine }





procedure TForm_TRACE.ASM_Zeile_anzeigen(Adresse : Word);
var
  Zeile_nicht_gefunden : Boolean;
  STR_Adresse : String;
  Zaehler : Integer;


begin

  STR_Adresse:=IntToHex(Adresse,4);
  Zeile_nicht_gefunden:=true;
  for Zaehler:=0 to List_Array_Zeiger do begin
    if Zeile_nicht_gefunden then begin
      if List_Array[Zaehler].Adresse=STR_Adresse then begin
        Form_TRACE.SynEdit_Z80_ASM.CaretY:=List_Array[Zaehler].ZeilenNr+12;
        SynEditSelLine(List_Array[Zaehler].ZeilenNr+1,Form_TRACE.SynEdit_Z80_ASM);
        Zeile_nicht_gefunden:=false;
      end;
    end;
  end; { for Zaehler:=0 to List_Array_Zeiger do }


end; { procedure TForm_TRACE.ASM_Zeile_anzeigen }










procedure TForm_TRACE.SynEdit_Z80_ASMGutterClick(Sender: TObject; X, Y,
                                                 Line: integer; mark: TSynEditMark);


var
  Zeile_nicht_gefunden : Boolean;
  STR_Adresse : String;
  Zaehler : Integer;


    procedure Add_Gutter(ZeiNr : Integer);
    var
      m: TSynEditMark;
    begin
      m := TSynEditMark.Create(SynEdit_Z80_ASM);
      m.Line := ZeiNr;
      m.Visible := true;
      m.ImageList := ImageList1;
      m.ImageIndex := 1;
      SynEdit_Z80_ASM.Marks.Add(m);

    end;



begin

  ARRAY_Zeilen_markieren;

  Zeile_nicht_gefunden:=true;
  for Zaehler:=0 to List_Array_Zeiger do begin
    if Zeile_nicht_gefunden then begin
      if List_Array[Zaehler].ZeilenNr=Line-1 then begin
        TForm_BUTTONS.Adresse_setzen(List_Array[Zaehler].Adresse);
        Add_Gutter(Line);
        Zeile_nicht_gefunden:=false;
      end;
    end;
  end; { for Zaehler:=0 to List_Array_Zeiger do }


end; { procedure TForm_TRACE.SynEdit_Z80_ASMGutterClick }











// Ende


procedure TForm_TRACE.FormDestroy(Sender: TObject);
begin

  ASM_Source.Free;

  Form_EMUZ80.TRACE_Left:=Form_TRACE.Left;
  Form_EMUZ80.TRACE_Top:=Form_TRACE.Top;

  Form_EMUZ80.TRACE_Width:=Form_TRACE.Width;
  Form_EMUZ80.TRACE_Height:=Form_TRACE.Height;

end; { procedure TForm_TRACE.FormDestroy }









initialization
  {$I mainform_trace.lrs}

end.

